script.on_init(function (event)
    save(nil)
end)

script.on_event(defines.events.on_player_joined_game, function (event)
    local player = game.players[event.player_index]
    player.print("Use /save-selected and /print-saved")
end)

commands.add_command("save-selected", "- saves the currently selected entity", function (event)
    local entity = game.players[event.player_index].selected
    save(entity)
    game.print("Saving selected entity: " .. entity_to_string(entity))
end)

commands.add_command("print-saved", "- prints the saved entity", function (event)
    local entity1, entity2 = load()
    game.print("Saved entity (method 1): " .. entity_to_string(entity1))
    game.print("Saved entity (method 2): " .. entity_to_string(entity2))
end)

function save(entity)
    global.save1 = entity
    global.save2 = {
        [{entity}] = true,
    }
end

function load()
    return global.save1, next(global.save2)[1]
end

function entity_to_string(entity)
    if entity == nil then
        return "nil"
    elseif not entity.valid then
        return "invalid"
    else
        return entity.name .. "#" .. tostring(entity.unit_number)
    end
end
